## ----echo=F---------------------------------------------------------------------------
#unha vez que se ten o codigo listo, e de cara a sacar un documento limpo podense inicializar uns
#parámetros, que me eviten a apariciónde avisos, a non ser que sexan erros 
knitr::opts_chunk$set(warning=FALSE)
knitr::opts_chunk$set(message=FALSE)
#que significa knitr::algo_mais?
#ese par de "dous puntos" indica que queremos usar un comando dun paquete 
#que non está subido á memoria con library. Só nos interesa puntualmente, 
#polo que só usamos ese comando con referencia ao nome do paquete


## -------------------------------------------------------------------------------------
#cargar quantmod, para ver ben os datos
library(quantmod)
#Cargar os datos gardados:
load("gspc.Rdata")
#que hai aquí?
head(gspc)


## -------------------------------------------------------------------------------------
#graficar os datos
plot(gspc)


## -------------------------------------------------------------------------------------
# Pode facerse cun só comando de quantmod:
#calculo dos retornos dos logaritmos
serie=Delt(gspc,type="log")
#este comando sempre produce un NA na 1ª posición, que pode dar problemas mais tarde.
# mellor quitarllo:
serie=na.omit(serie)


## -------------------------------------------------------------------------------------
# graficar os datos
plot(serie)


## -------------------------------------------------------------------------------------
#augmented Dickey-Fuller, Phillips-Perron, kpss, 
library(tseries)
adf.test(serie) # p-value < 0.05 indicates the TS is stationary
pp.test(serie)# p-value < 0.05 indicates the TS is stationary
kpss.test(serie)# AO REVES: p-value < 0.05 indicates the TS isn't stationary



## -------------------------------------------------------------------------------------
## Hai autocorrelacion?
#Ljung-Box
Box.test(serie,lag=10)


## -------------------------------------------------------------------------------------
## Como e' esa autocorrelacion
### autocorrelacion: acf()
acf(serie)
pacf(serie)

## Para que se vexa mellor o acf:
acf(serie,ylim=c(-0.3,0.3))
library(forecast)
ggtsdisplay(serie)



## -------------------------------------------------------------------------------------
estimacion10=arima(serie,order=c(1,0,0))#AR(1)
#intervalos de confianza
confint(estimacion10)


## -------------------------------------------------------------------------------------
estimacion20=arima(serie,order=c(2,0,0))#AR(2)
#intervalos de confianza
confint(estimacion20)


## -------------------------------------------------------------------------------------
estimacion21=arima(serie,order=c(2,0,1))#ARMA(2,1)
#intervalos de confianza
confint(estimacion21)


## -------------------------------------------------------------------------------------
estimacion22=arima(serie,order=c(2,0,2))#ARMA(2,2)
#intervalos de confianza
confint(estimacion22)


## -------------------------------------------------------------------------------------
estimacion11=arima(serie,order=c(1,0,1))#ARMA(1,1)
#intervalos de confianza
confint(estimacion11)


## -------------------------------------------------------------------------------------
estimacion12=arima(serie,order=c(1,0,2))#ARMA(1,2)
#intervalos de confianza
confint(estimacion12)


## -------------------------------------------------------------------------------------
estimacion02=arima(serie,order=c(0,0,2))#MA(2)
#intervalos de confianza
confint(estimacion02)


## -------------------------------------------------------------------------------------
estimacion01=arima(serie,order=c(0,0,1))#MA(1)
#intervalos de confianza
confint(estimacion01)



## -------------------------------------------------------------------------------------
AIC(estimacion10,estimacion20,estimacion11,estimacion01,estimacion02)
BIC(estimacion10,estimacion20,estimacion11,estimacion01,estimacion02)



## -------------------------------------------------------------------------------------
# 1º: obter os residuos
residuos1=estimacion20$residuals

Box.test(residuos1,lag=10)


## -------------------------------------------------------------------------------------
#correlogramas
acf(residuos1,ylim=c(-0.3,0.3))
pacf(residuos1)


## -------------------------------------------------------------------------------------
save(serie,residuos1,estimacion20,file="resultados_apartado1a.Rdata")

